;;; wrapper.exe  asirgui.el  c:/asir/bin/ ɒuĂƂ.
;;; (1) ~/.emacs  ǉ.
;;;     (load "c:/asir/bin/asirgui")
;;; (2) meadow  asirgui N.
;;; (3) meadow  foo.rr ҏW. (Asir ̃\[X)
;;;     ҏW̃\[X load ɂ́Aj[
;;;     Edit -> Send this file to asirgui.
;;;     I.

(defvar asirgui-wrapper-program "c:/asir/bin/wrapper.exe")

(defun asirgui-open () 
  (if (not (and (boundp 'asirgui) asirgui))
	  (setq asirgui (start-process "asirgui" "asirgui" asirgui-wrapper-program))))

(defun asirgui-close ()
  (if (and (boundp 'asirgui) asirgui)
	  (progn (delete-process asirgui)
			 (setq asirgui nil))))

;; Example
;(asirgui-exec-string "diff(x^20-1,x);")
(defun asirgui-exec-string (str)
  (interactive)
  (if (stringp str)
	  (progn
		(asirgui-open)
		(process-send-string asirgui (if (string-match "\n$" str) str (concat str "\n")))
;;		(asirgui-close)
		)))

(defun asirgui-load-buffer ()
  (interactive)
  (if (buffer-file-name)
	  (asirgui-exec-string (format "load(\"%s\");" (buffer-file-name)))
	(message "error: no file name")))

;; menu
(define-key menu-bar-edit-menu [run-asir]
  '("Send this file to asirgui." . asirgui-load-buffer))
